#pragma once

#include "IRenderTarget.hpp"
#include "Types.hpp"

namespace TSE
{
    class IWindow : public IRenderTarget
    {
        public:
        static IWindow* lastWindow;
        string title;

        protected:
        virtual bool Init() = 0;
        public:
        virtual void Clear() const = 0;
        virtual void Update() const = 0;
        virtual void ClearDepthBuffer() const = 0;
        virtual bool ShouldClose() const = 0;

        bool BaseInit() const;
        void BaseUpdate() const;
        ~IWindow();
    };
} // namespace TSE
